# MusicWindow Struct Reference

Inheritance diagram for MusicWindow:

## Public Member Functions
| MusicWindow (const WindowDesc *desc, WindowNumber number)
virtual void | UpdateWidgetSize (int widget, Dimension *size, const Dimension &padding, Dimension *fill, Dimension *resize)
| Update size and resize step of a widget in the window.
virtual void | DrawWidget (const Rect &r, int widget) const
| Draw the contents of a nested widget.
virtual void | OnPaint ()
| The window must be repainted.
virtual void | OnInvalidateData (int data=0)
| Some data on this window has become invalid.
virtual void | OnClick (Point pt, int widget, int click_count)
| A click with the left mouse button has been made on the window.
## Static Public Attributes
static const int | slider_width = 3

## Detailed Description

Definition at line 531 of file music_gui.cpp.

## Member Function Documentation

virtual void MusicWindow::DrawWidget | ( | const Rect & | r,
|  | int | widget |
| ) |  |  | const`[inline, virtual]`

Draw the contents of a nested widget.

Parameters:

  | r | Rectangle occupied by the widget.
  | widget | Number of the widget to draw.

Note:
  This method may not change any state, it may only use drawing functions.

Reimplemented from Window.

Definition at line 580 of file music_gui.cpp.

References _dynlang, _music_wnd_cursong, _song_is_active, DrawFrameRect(), DrawString(), FR_LOWERED, GetSongName(), GetTrackNumber(), GfxFillRect(), SA_CENTER, SetDParam(), SetDParamStr(), TD_RTL, DynamicLanguages::text_dir, WD_FRAMERECT_LEFT, WD_FRAMERECT_RIGHT, and WD_FRAMERECT_TOP.

virtual void MusicWindow::OnClick | ( | Point | pt,
|  | int | widget,
|  | int | click_count |
| ) |  |  | `[inline, virtual]`

A click with the left mouse button has been made on the window.

Parameters:

  | pt | the point inside the window that has been clicked.
  | widget | the clicked widget.
  | click_count | Number of fast consecutive clicks at same position

Reimplemented from Window.

Definition at line 646 of file music_gui.cpp.

References _dynlang, _left_button_clicked, _song_is_active, Window::SetDirty(), Window::SetWidgetDirty(), Window::SetWidgetLoweredState(), TD_RTL, and DynamicLanguages::text_dir.

virtual void MusicWindow::OnInvalidateData | ( | int | data = `0` | ) | `[inline, virtual]`

Some data on this window has become invalid.

Parameters:

  | data | information about the changed data.

Reimplemented from Window.

Definition at line 638 of file music_gui.cpp.

References Window::SetDirty(), and Window::SetWidgetLoweredState().

virtual void MusicWindow::OnPaint | ( |  | ) | `[inline, virtual]`

The window must be repainted.

Note:
  This method should not change any state, it should only use drawing functions.

Reimplemented from Window.

Definition at line 633 of file music_gui.cpp.

References Window::DrawWidgets().

virtual void MusicWindow::UpdateWidgetSize | ( | int | widget,
|  | Dimension * | size,
|  | const Dimension & | padding,
|  | Dimension * | fill,
|  | Dimension * | resize |
| ) |  |  | `[inline, virtual]`

Update size and resize step of a widget in the window.

After retrieval of the minimal size and the resize-steps of a widget, this function is called to allow further refinement, typically by computing the real maximal size of the content. Afterwards, size is taken to be the minimal size of the widget and resize is taken to contain the resize steps. For the convenience of the callee, padding contains the amount of padding between the content and the edge of the widget. This should be added to the returned size.

Parameters:

  | widget | Widget number.
  | size | Size of the widget.
  | padding | Recommended amount of space between the widget content and the widget edge.
  | fill | Fill step of the widget.
  | resize | Resize step of the widget.

Reimplemented from Window.

Definition at line 541 of file music_gui.cpp.

References _dynlang, GetSongName(), GetStringBoundingBox(), maxdim(), NUM_SONGS_AVAILABLE, SetDParamStr(), TD_RTL, DynamicLanguages::text_dir, WD_FRAMERECT_BOTTOM, WD_FRAMERECT_LEFT, WD_FRAMERECT_RIGHT, and WD_FRAMERECT_TOP.

The documentation for this struct was generated from the following file:

- src/music_gui.cpp